source: MondoRescue/branches/2.2.9/mindi-busybox/testsuite/runtest

Last change on this file was 3320, checked in by Bruno Cornec, 9 years ago
  • Re-add (thanks git BTW) the 2.2.9 branch which had been destroyed in the move to 3.0
  • Property svn:executable set to *
File size: 3.9 KB
Line 
1#!/bin/sh
2# Usage:
3# runtest [applet1] [applet2...]
4
5. ./testing.sh
6
7total_failed=0
8
9# Run one old-style test.
10# Tests are stored in applet/testcase shell scripts.
11# They are run using "sh -x -e applet/testcase".
12# Option -e will make testcase stop on the first failed command.
13run_applet_testcase()
14{
15 local applet="$1"
16 local testcase="$2"
17
18 local status=0
19 local uc_applet=$(echo "$applet" | tr a-z A-Z)
20 local testname="$testcase"
21
22 testname="${testname##*/}" # take basename
23 if grep "^# CONFIG_$uc_applet is not set$" "$bindir/.config" >/dev/null; then
24 echo "UNTESTED: $testname"
25 return 0
26 fi
27
28 if grep "^# FEATURE: " "$testcase" >/dev/null; then
29 local feature=$(sed -ne 's/^# FEATURE: //p' "$testcase")
30
31 for f in $feature; do
32 if grep "^# $f is not set$" "$bindir/.config" >/dev/null; then
33 echo "UNTESTED: $testname"
34 return 0
35 fi
36 done
37 fi
38
39 rm -rf ".tmpdir.$applet"
40 mkdir -p ".tmpdir.$applet"
41 cd ".tmpdir.$applet" || return 1
42
43# echo "Running testcase $testcase"
44 d="$tsdir" \
45 sh -x -e "$testcase" >"$testname.stdout.txt" 2>&1 || status=$?
46 if [ $status -ne 0 ]; then
47 echo "FAIL: $testname"
48 if [ x"$VERBOSE" != x ]; then
49 cat "$testname.stdout.txt"
50 fi
51 else
52 echo "PASS: $testname"
53 fi
54
55 cd ..
56 rm -rf ".tmpdir.$applet"
57
58 return $status
59}
60
61# Run all old-style tests for given applet
62run_oldstyle_applet_tests()
63{
64 local applet="$1"
65 local status=0
66
67 for testcase in "$tsdir/$applet"/*; do
68 # switch on basename of $testcase
69 case "${testcase##*/}" in
70 .*) continue ;; # .svn, .git etc
71 *~) continue ;; # backup files
72 "CVS") continue ;;
73 \#*) continue ;; # CVS merge residues
74 *.mine) continue ;; # svn-produced junk
75 *.r[0-9]*) continue ;; # svn-produced junk
76 esac
77 run_applet_testcase "$applet" "$testcase" || status=1
78 total_failed=$((total_failed + status))
79 done
80 return $status
81}
82
83
84
85lcwd=$(pwd)
86[ x"$tsdir" != x"" ] || tsdir="$lcwd"
87[ x"$bindir" != x"" ] || bindir="${lcwd%/*}" # one directory up from $lcwd
88PATH="$bindir:$PATH"
89export bindir # some tests need to look at $bindir/.config
90
91if [ x"$VERBOSE" = x ]; then
92 export VERBOSE=
93fi
94
95if [ x"$1" = x"-v" ]; then
96 export VERBOSE=1
97 shift
98fi
99
100implemented=$(
101 printf "busybox " # always implemented
102 "$bindir/busybox" 2>&1 |
103 while read line; do
104 if [ x"$line" = x"Currently defined functions:" ]; then
105 xargs | sed 's/,//g'
106 break
107 fi
108 done
109 )
110
111applets="$implemented"
112if [ $# -ne 0 ]; then
113 applets="$@"
114fi
115
116# Populate a directory with links to all busybox applets
117
118LINKSDIR="$bindir/runtest-tempdir-links"
119
120# Comment this line out if you have put a different binary in $LINKSDIR
121# (say, a "standard" tool's binary) in order to run tests against it:
122rm -rf "$LINKSDIR" 2>/dev/null
123
124mkdir "$LINKSDIR" 2>/dev/null
125for i in $implemented; do
126 # Note: if $LINKSDIR/applet exists, we do not overwrite it.
127 # Useful if one wants to run tests against a standard utility,
128 # not an applet.
129 ln -s "$bindir/busybox" "$LINKSDIR/$i" 2>/dev/null
130done
131
132# Set up option flags so tests can be selective.
133export OPTIONFLAGS=:$(
134 sed -nr 's/^CONFIG_//p' "$bindir/.config" |
135 sed 's/=.*//' | xargs | sed 's/ /:/g'
136 ):
137
138status=0
139for applet in $applets; do
140 # Any old-style tests for this applet?
141 if [ -d "$tsdir/$applet" ]; then
142 run_oldstyle_applet_tests "$applet" || status=1
143 fi
144
145 # Is this a new-style test?
146 if [ -f "$applet.tests" ]; then
147 if [ ! -e "$LINKSDIR/$applet" ]; then
148 # (avoiding bash'ism "${applet:0:4}")
149 if ! echo "$applet" | grep "^all_" >/dev/null; then
150 echo "SKIPPED: $applet (not built)"
151 continue
152 fi
153 fi
154# echo "Running test $tsdir/$applet.tests"
155 PATH="$LINKSDIR:$tsdir:$bindir:$PATH" \
156 "$tsdir/$applet.tests"
157 rc=$?
158 total_failed=$((total_failed + rc))
159 test $rc -ne 0 && status=1
160 fi
161done
162
163# Leaving the dir makes it somewhat easier to run failed test by hand
164#rm -rf "$LINKSDIR"
165
166if [ $status -ne 0 ] && [ x"$VERBOSE" = x ]; then
167 echo "$total_failed failure(s) detected; running with -v (verbose) will give more info"
168fi
169exit $status
Note: See TracBrowser for help on using the repository browser.